
########################################################################
#  popsocket.pl is a library needed by webmail.cgi                     #
#  version 1.22                                                        #
########################################################################
# WebMail is copyright 1995 CRS4 - Luca Manunza/Gianluigi Zanetti.     #
# The information (of all forms) in these files is the intellectual    #
# property of the Centro di Ricerca, Sviluppo e Studi Superiori in     #
# Sardegna (known as CRS4 - Center for Advanced Studies, Research and  #
# Development in Sardinia).                                            #
# No guarantee whatsoever is provided by CRS4. No liability whatsoever #
# is accepted for any loss or damage of any kind resulting from any    #
# defect or inaccuracy in this information or code.                    #
#                                                                      #
# Author: Luca Manunza <bilbo@crs4.it>                                 #
#                                                                      #
# First version: 20-02-1995                                            #
# Last Update  : 28-04-1995                                            #
########################################################################

#############################

$AF_INET = 2;
$SOCK_STREAM = 1;

$sockaddr = 'S n a4 x8';
$this = "";
$that = "";
THESOCKET;

sub socketinit {
    local ($them,$port)=@_;
    local ($hostname)=`hostname`;
    local ($name,$aliases,$type,$len,$proto);
    local ($thisaddr,$thataddr);
    chop($hostname);

    ($name,$aliases,$proto) = getprotobyname('tcp');
    ($name,$aliases,$type,$len,$thisaddr) = gethostbyname($hostname);
    ($name,$aliases,$type,$len,$thataddr) = gethostbyname($them);
    
    $this = pack($sockaddr, $AF_INET, 0, $thisaddr);
    $that = pack($sockaddr, $AF_INET, $port, $thataddr);

# Make the socket filehandle.

    return 0 unless (socket(THESOCKET, $AF_INET, $SOCK_STREAM, $proto));
 
# Give the socket an address.
    
    return 0 unless (bind(THESOCKET, $this));

    return 1;
}


sub popopen {

    return 0 unless (connect(THESOCKET, $that));
    select(THESOCKET); $| = 1; 
    select(STDOUT);

    local($s,$r)= &popquery("NO_POP_QUERY",0); # waste the +OK server message
    return $s;
}

sub sendmailopen {

    return 0 unless (connect(THESOCKET, $that));
    select(THESOCKET); $| = 1; 
    select(STDOUT);

    return '+OK';
}


sub listenline {
    local($break) = @_;
    local($return,$tmp) = "";

    while(<THESOCKET>) {
	$return .= $_;
	last if (/$break/i);
    }
    #remove the byte-stuff and carriage-return
    $return =~ s/\.\./\./g;
    $return =~ s/\r//g;

    $return;
}

sub popclose {
    local($s,$r)= &popquery("quit",0); # clean exit sequence
    shutdown(THESOCKET, 2);
}

sub sendmailclose {
    local($s,$r)= &sendmailquery("quit",0); # clean exit sequence
    shutdown(THESOCKET, 2);
}

sub popquery {
    local($query,$multi)=@_;
    local($success,$answer);

    if($query ne "NO_POP_QUERY") {
	print THESOCKET $query . "\n";
    }
    
    local($linein)= &listenline("\r\n");

    if($linein =~ m/^\-ERR /) {
	$answer = "$'\n";
	$success = '-ERR';     
    } else {
	$linein =~ m/^\+OK /;
	$answer = "$'";
	$success = '+OK';

	$answer .= &listenline("^\\\.\r\n") if ($multi !=0);

	$answer .= "\n";
    }

    return($success,$answer);
}


sub sendmailquery {
    local($query,$multi)=@_;
    local($success,$answer);

    if($query ne "NO_SMAIL_QUERY") {
	print THESOCKET $query . "\n";
    }
    
    $brkpat = $multi != 0 ? "^\.\r\n" : "\r\n" ;

    local($linein);
    do {
	$linein= &listenline($brkpat);
    } while ($linein =~ m/^220/);

    if(($linein =~ m/^250 /)||($linein =~ m/^221 /)) { # generic ok and quit
	$answer .= "$'\n";
	$success = '+OK';     
    } elsif($linein =~ m/^354 /) { # wait for data
	$answer .= "$'\n";
	$success = '+OK';     
    }else {
	$answer .= $linein;
	$success = '-ERR';
    }
    
    return($success,$answer);
}


### popaccess (HANDLE, USER, PASSWORD) is a macro for pop login sequence ###
sub popaccess {
    
    local($user,$passwd) =@_;
    
    local($s,$r)= &popquery("user $user",0);
    
    if($s ne '-ERR') {
	($s,$r)= &popquery("pass $passwd",0);
    } 
    return ($s, $r) ;			# $s is -ERR or +OK
}

### popdele 
sub popdele {
    
    local($msgnum) =@_;
    
    local($s,$r)= &popquery("dele $msgnum",0);
    
    return $s;			# $s is -ERR or +OK
}

sub poplist {
    local(@lista);
    
    local($s,$r) = &popquery("list",1);
    @lista = split("\n",$r);
    
    local($i,@tmp);

    for($i=1; $i < $#lista; $i++) {
	@tmp =split(" ",$lista[$i]);
	$lista[$i] = $tmp[0];
    }

    return ($s,@lista);
}

sub popretr{
    local($msgnum,$howmanylines)=@_;
    local($from,$to,$ccopy,$subject,$date,$msgid,$size,$text);
    local(@lista);
    local($s,$r);

    ($s,$r) = &popquery("retr $msgnum",1);

    if($s eq '+OK') {

	@lista = split("\n",$r);
	
	#get the size
	$lista[0] =~ m/(\d+)\s+octe/i;
	$size=$1;
	
	local($i,$cmd,$val);

	#### strange mail reader bug fix ####
	local($fromfound)=0;

	# read the header

	for($i=1; $i<$#lista; $i++) {

	    if($lista[$i] eq "") { 
		if($fromfound==1) { # start of text found!
		    $i++;
		    last;
		} else {
		    #### it's only the @#&*$%@ error of a strange mail reader ####
		    next;
		}
	    }

	    $lista[$i] =~ m/^(\S+): /i;
	    $cmd = $1;
	    $val = $';
	    
	    if($cmd =~ /^From$/i) {
		$from = $val;
		$fromfound=1;	#### now i'm sure that the next void line is the start of text (i hope...)####
	    } 
	    elsif($cmd =~ /^To$/i) {
		$to = $val;
	    }
	    elsif($cmd =~ /^Cc$/i) {
		$ccopy = $val;
	    }
	    elsif($cmd =~ /^Subject$/i) {
		$subject = $val; 
	    }
	    elsif($cmd =~ /^Date$/i) {
		$date = $val;
	    }
	    elsif($cmd =~ /^Message-Id$/i) {
		$msgid = $val;
	    }
		
	}


	#get the first $howmanylines lines
	local($lines) = 0;

	if($lista[$i] ne "\.") {
	    for(;$i < $#lista; $i++) {
		if($howmanylines ne "allmsg") {
		    last if ($lines >= $howmanylines);
		}
		$text .= $lista[$i] . "\n";
		$lines++;
	    }
	}
    }


    return ($s,$from,$to,$ccopy,$subject,$date,$msgid,$size,$text);
}





###### this 1 (one) at the end of file is for "require" #######
1;				# return true


















