#!/usr/local/bin/perl
########################################################################
#  Webmail is a cgi script that let you read your mail from            #
#  a WWW browser like Mosaic or Netscape                               #
#  Version 1.22                                                        #
########################################################################
# WebMail is copyright 1995 CRS4 - Luca Manunza/Gianluigi Zanetti.     #
# The information (of all forms) in these files is the intellectual    #
# property of the Centro di Ricerca, Sviluppo e Studi Superiori in     #
# Sardegna (known as CRS4 - Center for Advanced Studies, Research and  #
# Development in Sardinia).                                            #
# No guarantee whatsoever is provided by CRS4. No liability whatsoever #
# is accepted for any loss or damage of any kind resulting from any    #
# defect or inaccuracy in this information or code.                    #
#                                                                      #
# Author: Luca Manunza <bilbo@crs4.it>                                 #
#                                                                      #
# First version: 20-02-1995                                            #
# Last Update  : 28-04-1995                                            #
########################################################################






# Pathinfos from WWW browser

# 0+0/0+0/access
# 0+0/0+0/access/logon
# userid+USERKEY/POPSERVER+POPPORT/maillist/read
# userid+USERKEY/POPSERVER+POPPORT/maillist/delform
# userid+USERKEY/POPSERVER+POPPORT/maillist/delete
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/read
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/delete
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/reply
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/replyinclude
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/compose
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/forward
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/send
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/save/MESSID

# database record template  

# USERID+PASSWORD+IPADDRESS+TIMESTAMP    <--- secs from 01/01/1970


######## config variables #############

$cgipath = "/cgi-bin"; # where the HTTPD looks for cgi scripts

$webmaildir = "/usr/local/src/webmail"; # where you have expanded the webmail distribution

$dbname = "$webmaildir/.workdir/.webmaildb"; # dbm-file (without .pag/.dir extension) for user's data

$dblockfile = "$webmaildir/.workdir/.webmaillock"; # file used as alias of the dbm-file 
                                           # for lock/unlock operations

$popserver = "default.popserver.host"; # default popserver

$popport = 110;			# standard popserver port number

$sendmailserver = $popserver;	# default sendmail server

$sendmailport = 25;		# standard sendmail port number

$elog = "$webmaildir/.workdir/webmail_error.log"; # error-log file name

$alog = "$webmaildir/.workdir/webmail_access.log"; # access-log file name

$icondir = "$webmaildir/icons"; # path for icons

$timeout = 600;			# user password expiration time in seconds

$linesinlist = 0;		# how many lines of msg text must appear in Mail List Page
				# 0 means that only Sender and Subject fields will appear

$userdomain = "";		# the default user domain:
				# if you have a network architecture that masks the
				# true address of users (eg. "bilbo" is "bilbo@crs4.it"),
				# then put the domain into this variable ("crs4.it");
				# if you don't, the user "bilbo" will be "bilbo@$popserver".

$popchangeON = 1;		# change this to disable the popserver change feature

# the list of popservers : format is "NAME","FULL.NETWORK.ADDRESS"
%popserverlist = (
		  "default",$popserver,	# do not change/remove this one
		  );
				

########################################

# search the webmail directory

local($execpath);
$execpath = $0;
$execpath =~ s/\/webmail\.cgi//i;

# include a configuration file in perl (override the previous defs)
require "$execpath/webmail.conf" if (-e "$execpath/webmail.conf"); 				         


push (@INC,"$webmaildir/cgi-bin");
require 'popsocket.pl';		# library for socket connections
require 'cgiparse.pl';		# library to parse cgi arguments


######## utility function ########
$html_region = 0 ;

sub HTMLgtlt {
    local($ch)=@_;
    return '&gt;' if ($ch eq ">");
    return '&lt;' if ($ch eq "<");
}

sub HTMLpush {
    local ($entry) = @_ ;
    local ($key) = " \003HTML-$html_region ";
    $html{$key} = $entry ;
    $html_region++ ;
    return ($key) ;
}

######## log functions ###########
sub ALOG {

    local($r)=open(LOGFILE,">>$alog");

    local($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    local($pre)=sprintf("[%02d/%02d/%02d %02d:%02d:%02d]",$mday,$mon+1,$year,$hour,$min,$sec);

    if($r) {
	foreach $str (@_) {
	    print LOGFILE "$pre $str\n";
	}
	close LOGFILE;
    } 
}


sub ELOG {

    local($r)=open(LOGFILE,">>$elog");

    if($r) {
	foreach $str (@_) {
	    print LOGFILE "$str\n";
	}
	close LOGFILE;
    } 
}

####### lock dbmfile functions ########

# test for flock implementation
$NO_FLOCK = 0;	
eval { flock(X,8); };
$NO_FLOCK = 1 	if($@ =~ /flock.*unimplemented/i);
# this will patch the flock absence in hpux


LOCKFILE;			# this is the lock file handle
$LOCK_EX = 2;
$LOCK_UN = 8;

$F_SETLKW = 7;
$F_UNLCK = 3;
$F_SETLK = 6;
$F_WRLCK = 2;

sub hpuxflock {

  local($cmd)=@_;
  local($structflock);
  local($action,$command);
  local($retval)=0;
  
  if($cmd == 8) {	# is a LOCK_UN
	$command=$F_SETLKW;
	$action=$F_UNLCK;
  } elsif($cmd == 4) {	# is a LOCK_NB
	$command=$F_SETLK;
  	$action=$F_WRLCK;
  } elsif($cmd == 2) {	# is a LOCK_EX
	$command=$F_SETLKW;
  	$action=$F_WRLCK;
  } elsif($cmd == 1) {	# is a LOCK_SH
	$command=$F_SETLKW;
  	$action=$F_WRLCK;
  	# implemented as LOCK_EXCLUSIVE... for now is not so bad. :-)
  } else {		# Syntax Error
  	&ELOG("Unhandled value for cmd parameter in hpuxflock");
  	return 0;
  }

  $struct_flock=pack('s2l3',$action,0,0,0,0);
  
  if(fcntl(LOCKFILE,$command,$struct_flock) == -1) {
    $retval=0;
  } else {
    $retval=1;
  }
 
  return $retval;
}   

sub LockDbmFile {
    local ($retval);
    open(LOCKFILE,">$dblockfile");

    if($NO_FLOCK == 0) {
        $retval=flock(LOCKFILE,$LOCK_EX);
    } else {
        $retval = &hpuxflock($LOCK_EX);
    }
    close LOCKFILE unless $retval;

    return $retval;
}

sub UnlockDbmFile {
    if($NO_FLOCK == 0) {
        flock(LOCKFILE,$LOCK_UN);
    } else {
        &hpuxflock($LOCK_UN);
    }
    close LOCKFILE;
}

####### createkey function ########
# make a key for USER + PASSWD 
# 

sub createkey {
    local($u,$p) = @_;		# unused ...
    local($randomkey);
    # randomize timer
    srand;
    
    $randomkey = rand;
    $randomkey =~ s/^0\.//;
    $randomkey = substr($randomkey,-9);

    return $randomkey;
}

####### splitkey function ########
# splits the key -> cryptkey - indexkey 
# 

sub splitkey {
    local($key) = @_;		
    local($ckey,$ikey);

    $ckey = $key;
    $ikey = "";

    return ($ckey,$ikey);
}

####### cryptstring function ########
# (de)crypt a string

sub cryptstring {
    local($key,$str) = @_;
    local($strlen)=length($str);
    local($j);

    srand($key);

    for ($j=0;$j<$strlen;$j++) {
	local($ch,$kc);
	$ch=substr($str,$j,1);
	$ch=ord($ch);
	$kc=int(rand(255));
	$ch=$ch ^ $kc;
	$ch=pack("C",$ch);

	substr($str,$j,1)= $ch;
    }

    return $str;
}


####### getuserrecord ########
# get a user record from dbm file

sub getuserrecord {
    local($uid,$ukey) = @_;
    local($ckey,$ikey)= &splitkey($ukey);
    local($thekey)=$uid . $ikey;
    local(%dbf);
    local($error,$record,$userpasswd,$timestamp);

    if(&LockDbmFile()) {
	if(!dbmopen(dbf,$dbname,0600))
	{
	    &ELOG("can't open dbm file");
	    $error="Unable to open your account";
	} else {
	    
	    $record = &cryptstring($ckey,$dbf{$thekey});
	    
	    if( $record =~ m/^$uid\+/ ) {
		($uid,$userpasswd,$userIP,$timestamp) = split('\+',$record);
		if ((time - $timestamp) > $timeout) {
		    &ELOG("user inactivity timeout expired");
		    $userpasswd="";
		    $error="Inactivity timeout expired.<P>Your password is no longer valid";

		    delete $dbf{$thekey}; 
		} elsif($userIP ne $callIP) {
		    $hacker=$ENV{"HTTP_FROM"};
		    &ELOG("changed IP address OLD=$userIP NEW=$callIP HACKER=$hacker");
		    $userpasswd="";
		    # I'm saying a lie, but I hope the hacker gets confused...
		    $error="Inactivity timeout expired.<P>Your password is no longer valid";
		} else {	    
		    $timestamp = time;
		    $dbf{$thekey} = &cryptstring($ckey,"$uid+$userpasswd+$callIP+$timestamp");
		}
	    } else {
		($uid,$userpasswd,$userIP,$timestamp) = split('\+',$record);
		if ((time - $timestamp) > $timeout) {
		    &ELOG("different user inactivity timeout expired");
		    $userpasswd="";
		    delete $dbf{$thekey}; 
		}		
		&ELOG("user key not matches the userid");
		$error="Unable to open your account";
	    }
	    
	    dbmclose dbf;
	}

	&UnlockDbmFile();

    } else {
	&ELOG("can't lock dbm file");
	$error="Unable to open your account";
	$userpasswd="";
    }
    
    return ($userpasswd,$error);
}


######## UserEMail #############
## this function builds the user's e-mail
## address testing the $userdomain and
## $popserver values

sub UserEMail {
    local($userid)=@_;
    local($email);

    if($userdomain ne "") {
	$email = "$userid\@$userdomain";
    } else {
	$email = "$userid\@$popserver";
    }

    return $email;
}

######## AskTruName ############
## this function is not directly related to POP server
## but uses the same protocol for open, query and close
## Ask user's true name to SendMail

sub AskTrueName {
    local ($userid)=@_;
    local($s,$r);
    local($truename);
    local($sendmail);

    
    $sendmail=&socketinit($sendmailserver,$sendmailport);
    $sendmail=&sendmailopen() if ($sendmail == 1);

    if($sendmail ne "+OK") {
	&ELOG("can't open sendmail socket");
	$s = '-ERR';
	$truename = "";
    } else {
	($s,$r)=&sendmailquery("vrfy $userid",0);
	if($s eq '+OK') {
	    $r =~ s/^$userid\.+\s*//i;
	    $r =~ m/^(.*) <(.*)>/i;
	    $truename = $1;
	} else {
	    &ELOG("sendmail verify userid failed","$r");
	    $truename = "";
	}
    }

    &sendmailclose();
    return ($s,$truename);
}


######## SendUserMessage ############
## Send a message via SendMail deamon

sub SendUserMessage {
    local ($userid,$dest,$ccopy,$subject,$text)=@_;
    local($s,$r);
    local($truename);
    local($sendmail);
    local($error);
    local(@ccs,$to);

    ($s,$truename)=&AskTrueName($userid);
    $s="+OK";

    $sendmail=&socketinit($sendmailserver,$sendmailport);
    $sendmail=&sendmailopen() if ($sendmail == 1);

    if($sendmail ne "+OK") {
	&ELOG("sending: can't open sendmail socket");
	$s = '-ERR';
	$error = "Unable to send your message \*";
    } else {
	($s,$r)=&sendmailquery("mail from: ".&UserEMail($userid),0);
	if($s eq '+OK') {
	    ($s,$r)=&sendmailquery("rcpt to: $dest",0);

	    if($ccopy ne "") {
		@ccs = split(",",$ccopy);
		foreach $to (@ccs) {
		    $to .= " ";
		    if($to =~ m/\s*<*([^<\s]+\@[^\s>]+)>*/) {
			$to = $1;
			($s,$r)=&sendmailquery("rcpt to: $to",0);
		    }
		}
	    }			

	    if($s eq '+OK') {
		local($msg);
		$msg .= "From: $truename <".&UserEMail($userid).">\n";
		$msg .= "To: $dest\n";
		$msg .= "Cc: $ccopy\n" if ($ccopy ne "");
		$msg .= "Subject: $subject \n\n";
		
		# byte stuff on single-dot lines
		$text =~ s/\n\./\n\.\./g;

		$msg .= "$text\n";

		($s,$r)=&sendmailquery("data",0);

		if($s eq '+OK') {
		    $error = "Your message has been sent";
		    ($s,$r)=&sendmailquery("$msg\.",0); 
		    if($s eq '+OK') {
			$error = "Your message has been sent";
		    } else {
			&ELOG("sending: msg-text refused");
			$s = '-ERR';
			$error = "Unable to send your message \*\*\*\*";	
		    }
		} else {
		    &ELOG("sending: data command refused");
		    $s = '-ERR';
		    $error = "Unable to send your message \*\*\*";	
		}
	    } else {
		&ELOG("sending: rcpt-to command refused");
		$s = '-ERR';
		$error = "Unable to send your message \*\*";	
	    }
	} else {
	    &ELOG("sending: mail-from command refused");
	    $s = '-ERR';
	    $error = "Unable to send your message";	
	}
    }

    &sendmailclose();
    return ($s,$error);
}


######## Copyright ########
# return the HTML string with the copyright notice

sub Copyright {
    local ($notice);
    $notice =  "<HR><H5>WebMail - Copyright \&copy; 1995 CRS4 Cagliari - Luca Manunza/Gianluigi Zanetti<BR>\n";
    $notice .= "<I>For more information please e-mail to <A HREF=\"mailto:webmail\@crs4.it\">webmail\@crs4.it</A>.</I></H5>\n";

    $notice;
}

######## AccessErrorPage #########
# return the HTML page with Error string and a link to the access page

sub AccessErrorPage {
    local($msg)=@_;
    local($page);

    $page  = "Content-type: text/html\n\n";
    $page .= "<HTML>\n<HEAD><TITLE> Access Error Page </TITLE></HEAD>\n";
    $page .= "<BODY>\n<H1>WebMail access error</H1>\n";
    $page .= "The server has reported:\n";
    $page .= "<H2>$msg</H2>\n";
    $page .= "Please follow this link to the correct ";
    $page .= "<A HREF=\"$cgipath/webmail.cgi/0+0/$popname+$popport/access\">WebMail Access Page</A>\n";
    $page .= &Copyright();
    $page .= "</BODY>\n</HTML>\n";

    return $page;
}

######## AccessPage #########
# return the HTML page with the form for USERNAME and PASSWORD

sub AccessPage {

    local($page);
    local($k);

    $page  = "Content-type: text/html\n\n";    
    $page .= "<HTML>\n<HEAD><TITLE> Access Page </TITLE></HEAD>\n";
    $page .= "<BODY>\n<H1>WebMail Access Page</H1>\n";
    $page .= "To access your mail you have to fill this form with your name and password.\n";
    $page .= "<HR>\n";

    $page .= "<FORM METHOD=\"post\" ACTION=\"$cgipath/webmail.cgi/0+0/$popname+$popport/access/logon\">\n";
    $page .= "USER NAME:<INPUT TYPE=\"text\" NAME=\"username\" SIZE=30><P>\n";
    $page .= "PASSWORD: <INPUT TYPE=\"password\" NAME=\"userpasswd\" SIZE=30><P>\n";

    if($popchangeON != 0) {
	$page .= "<HR>\n";
	$page .= "If you need it, you can specify here your POP server:<P>\n";
	$page .= "POP Server: <SELECT  NAME=\"popserver\" >\n";

	foreach $k (keys %popserverlist) {
	    if($k eq "default") {
		$page .= "<OPTION SELECTED> $k\n";
	    }
	    else {
		$page .= "<OPTION> $k\n";
	    }
	}
	$page .= "</SELECT>\n";	
    }
    
    $page .= "<PRE>           <INPUT TYPE=\"submit\" VALUE=\"  Go to maillist  \">         <INPUT TYPE=\"reset\" VALUE=\"  Clear  \"> </PRE>\n";
    $page .= "</FORM>\n";
    $page .= &Copyright();
    $page .= "</BODY>\n</HTML>\n";

    return $page;
}


######## MailListPage #########
# return the HTML page listing the user's mail

sub MailListPage {
    local($userid,$userkey,$userpasswd)=@_;
    local($page);
    local($s,$r);
    local(@lista);
    local($pop);
    local($closed) = 0 ;
    

    $page  = "Content-type: text/html\n\n";

    $page .= "<HTML>\n<HEAD><TITLE> MailList Page </TITLE></HEAD>\n";
    $page .= "<BODY>\n<H1>WebMail Mail List Page</H1>\n";
    $page .= "<H2>" . $userid . "\'s mail</H2>\n";
    $page .= "This is your actual mail. You can click on a subject to read the corresponding message.\n";
    $page .= "Please note that if your mail exceeds 100 Kbytes, you should consider removing the oldest messages,\n";
    $page .= "otherwise we will do it for you...<P>\n";

    # iconline
    $page .= "<HR>\n";
    $page .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/maillist/read\">";
    $page .= "<IMG ALT=\"Mail List\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/maillist.gif\">";
    $page .= "</A>\n";
    $page .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/message+0/compose\">";
    $page .= "<IMG ALT=\"Compose\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/compose.gif\">";
    $page .= "</A>\n";
    $page .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/maillist/delform\">";
    $page .= "<IMG ALT=\"Delete Multiple\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/delmulti.gif\">";
    $page .= "</A>\n";
    $page .= "<HR>\n";

# now create the mail list querying the server

    $pop=&socketinit($popserver,$popport);
    $pop=&popopen() if ($pop == 1);

    if($pop ne "+OK") {
	&ELOG("can't open popserver socket");
	$page= &AccessErrorPage("POP Server is not responding");
	return $page;
    }

    ($s,$r)=&popaccess($userid,$userpasswd);
    if ($s eq '-ERR' && $r =~ /Could not open VMS mail box/) {
	$s = '+OK' ;		
	$closed = 1 ;
    }

    if($s eq '+OK') {
	
	if ($closed) {
	    $s = '-ERR';
	} else {
	    ($s,@lista) = &poplist() ;
	}
	
	if(($s eq '+OK') && ($#lista > 1)) {

	    local($totalsize)=0;
	    $lista[0] =~ m/(\d+) /;
	    $page .= "We've $1 messages (_WEBMAIL_TOTALSIZE_TAG_ bytes) for you.<P>\n<UL>\n";

	    local($from,$to,$ccopy,$subject,$date,$msgid,$size,$line);
	    local($i);
	    for($i=1; $i<($#lista); $i++) {
		($s,$from,$to,$ccopy,$subject,$date,$msgid,$size,$line)=&popretr($lista[$i],$linesinlist);

		if($s eq '+OK') {

		    $totalsize += $size;

		    $from =~ s/([<>])/&HTMLgtlt($1)/ge;
		    $msgid =~ s/([<>])//g;
		    $line =~ s/([<>])/&HTMLgtlt($1)/ge;
		    $to =~ s/([<>])/HTMLgtlt($1)/ge;
		    $subject =~ s/([<>])/HTMLgtlt($1)/ge;

		    $subject = "No subject" if ($subject =~ /^\s*$/);

		    $page .= "<LI><B>$from</B> - ";
		    
		    $page .="<A NAME=\"" . $msgid ."\" HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/message+$lista[$i]/read\" ><I>$subject</I></A>\n";

		    if(($line ne "\n") && ($line ne "")) {
			$page .= "<UL><LI>\"$line\"</UL>\n";
		    }
		    
		} else {
		    $page .= "<LI>THIS MESSAGE IS MISSED\n";
		}
	    }

	    $page .="</UL>\n";

	    $page =~ s/_WEBMAIL_TOTALSIZE_TAG_/$totalsize/;

	} else {
	    $page .= "<B><I>Sorry, no messages for you.</I></B><P>\n";
	}

	# iconline
	$page .= "<HR>\n";
	$page .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/maillist/read\">";
	$page .= "<IMG ALT=\"Mail List\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/maillist.gif\">";
	$page .= "</A>\n";
	$page .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/message+0/compose\">";
	$page .= "<IMG ALT=\"Compose\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/compose.gif\">";
	$page .= "</A>\n";
	$page .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/maillist/delform\">";
	$page .= "<IMG ALT=\"Delete Multiple\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/delmulti.gif\">";
	$page .= "</A>\n";
	
	$page .= &Copyright();
	$page .= "</BODY>\n</HTML>\n";
	
    } else {
	
	&ELOG("wrong username or password");
	$page= &AccessErrorPage("Wrong username or password");
    }

    &popclose()
	if (!$closed) ;
    return $page;
}

######## DeleteMailListPage #########
# return the mail list for delete 

sub DeleteListPage {
    local($userid,$userkey,$userpasswd)=@_;
    local($page);
    local($s,$r);
    local(@lista);
    local($pop);
    

    $page  = "Content-type: text/html\n\n";

    $page .= "<HTML>\n<HEAD><TITLE> Delete MailList Page </TITLE></HEAD>\n";
    $page .= "<BODY>\n<H1>WebMail Delete Page</H1>\n";
    $page .= "<H2>" . $userid . "\'s mail</H2>\n"; 

    $page .= "Flag all the messages you want to discard from your mailbox, then press the <B><I>Delete</I></B> button\n";
    $page .= "Remember that you <B>can't recover</B> a discarded message.";

    # iconline
    $page .= "<HR>\n";
    $page .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/maillist/read\">";
    $page .= "<IMG ALT=\"Mail List\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/maillist.gif\">";
    $page .= "</A>\n";
    $page .= "<HR>\n";

# now create the mail list querying the server

    $pop=&socketinit($popserver,$popport);
    $pop=&popopen() if ($pop == 1);

    if($pop ne "+OK") {
	&ELOG("can't open popserver socket");
	$page= &AccessErrorPage("POP Server is not responding");
	return $page;
    }

    ($s,$r)=&popaccess($userid,$userpasswd);

    if($s eq '+OK') {
	
	($s,@lista) = &poplist();

	if(($s eq '+OK') && ($#lista > 1)) {

	    local($totalsize)=0;
	    $lista[0] =~ m/(\d+) /;
            $page .= "<FORM ACTION=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/maillist/delete\">\n";

	    $page .= "We've $1 messages (_WEBMAIL_TOTALSIZE_TAG_ bytes) for you.<P>\n<UL>\n";

	    local($from,$to,$ccopy,$subject,$date,$msgid,$size,$line);
	    local($i);
	    for($i=1; $i<($#lista); $i++) {
		($s,$from,$to,$ccopy,$subject,$date,$msgid,$size,$line)=&popretr($lista[$i],$linesinlist);

		if($s eq '+OK') {
		    $totalsize += $size;
		    
		    $from =~ s/([<>])/&HTMLgtlt($1)/ge;
		    $msgid =~ s/([<>])//g;
		    $line =~ s/([<>])/&HTMLgtlt($1)/ge;
		    $to =~ s/([<>])/HTMLgtlt($1)/ge;
		    $subject =~ s/([<>])/HTMLgtlt($1)/ge;

		    $subject = "No subject" if ($subject =~ /^\s*$/);

		    $page .= "<LI> <INPUT TYPE=CHECKBOX NAME=\"CHECK$lista[$i]\"> <B>$from</B> - <I>$subject</I>\n";

		    if(($line ne "\n") && ($line ne "")) {
			$page .= "<UL><LI>\"$line\"</UL>\n";
		    }
		    
		} else {
		    $page .= "<LI>THIS MESSAGE IS MISSED\n";
		}
	    }

	    $page .="</UL>\n";

	    $page =~ s/_WEBMAIL_TOTALSIZE_TAG_/$totalsize/;

	    $page .= "<center>\n";
	    $page .="<INPUT TYPE=submit VALUE=\"   Delete   \"> <INPUT TYPE=reset VALUE=\"   Clear All   \"></PRE>\n";
	    $page .="</center>\n";
	    $page .="</FORM>\n";

	} else {
	    $page .= "<B><I>Sorry, no messages for you.</I></B><P>\n";
	}

	# iconline
	$page .= "<HR>\n";
	$page .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/maillist/read\">";
	$page .= "<IMG ALT=\"Mail List\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/maillist.gif\">";
	$page .= "</A>\n";
	
	$page .= &Copyright();
	$page .= "</BODY>\n</HTML>\n";
	
    } else {
	&ELOG("wrong username or password");
	$page= &AccessErrorPage("Wrong username or password");
    }

    &popclose();
    return $page;
}

######## ParseDeleteForm #########
# delete all flagged messages in the Delete Mail List Page

sub ParseDeleteForm {
    local($userid,$userkey,$userpasswd)=@_;

    local($s,$r);
    local($pop,$key);


    $pop=&socketinit($popserver,$popport);
    $pop=&popopen() if ($pop == 1);

    if($pop ne "+OK") {
	&ELOG("can't open popserver socket");
	return;
    }
    
    ($s,$r)=&popaccess($userid,$userpasswd);

    if($s eq '+OK') {

	foreach $key (keys (%CGI)) {
	    if($key =~ m/^CHECK(\d+)/) {
		$msgnum = $1;
		($s,$r)=&popdele($1);
	    }
	}				
    }			

    &popclose();
    return;
}    

######## MakeIconLine ############
# build the HTML section of icon's line

sub MakeIconLine {
    local($userid,$userkey,$msgnum,$msgid)=@_;

    local ($line);
    
    $line .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/maillist/read\#$msgid\">";
    $line .= "<IMG ALT=\"Mail List\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/maillist.gif\">";
    $line .= "</A>\n";
    $line .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/message+$msgnum/delete\">";
    $line .= "<IMG ALT=\"Delete\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/delete.gif\">";
    $line .= "</A>\n";
    $line .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/message+$msgnum/reply\">";
    $line .= "<IMG ALT=\"Reply\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/reply.gif\">";
    $line .= "</A>\n";
    $line .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/message+$msgnum/replyinclude\">";
    $line .= "<IMG ALT=\"Reply-Include\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/replyinc.gif\">";
    $line .= "</A>\n";
    $line .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/message+$msgnum/forward\">";
    $line .= "<IMG ALT=\"Forward\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/forward.gif\">";
    $line .= "</A>\n";
    $line .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/message+$msgnum/compose\">";
    $line .= "<IMG ALT=\"Compose\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/compose.gif\">";
    $line .= "</A>\n";
    $line .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/message+$msgnum/save/MAIL$msgnum\">";
    $line .= "<IMG ALT=\"Save\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/save.gif\">";
    $line .= "</A>\n";
    
    return $line;
}

######## ReadMessagePage #########
# return the HTML page listing the user's mail

sub ReadMessagePage {
    local($userid,$userkey,$userpasswd,$msgnum)=@_;
    local($page);
    local($s,$r);
    local(@lista);
    local($pop);

    $pop=&socketinit($popserver,$popport);
    $pop=&popopen() if ($pop == 1);

    if($pop ne "+OK") {
	&ELOG("can't open popserver socket");
	$page= &AccessErrorPage("POP Server is not responding");
	return $page;
    }

    ($s,$r)=&popaccess($userid,$userpasswd);

    if($s eq '+OK') {
	
	local($from,$to,$ccopy,$subject,$date,$msgid,$size,$line);
	($s,$from,$to,$ccopy,$subject,$date,$msgid,$size,$line)=&popretr($msgnum,"allmsg");
	if($s eq '+OK') {
       	    $from =~ s/([<>])/&HTMLgtlt($1)/ge;
       	    $msgid =~ s/([<>])//g;
	    $subject =~ s/([<>])/HTMLgtlt($1)/ge;

	    $line =~ s/<HTML>/\001/gi ;
	    $line =~ s/<\/HTML>/\002/gi ;
	    $line =~ s/\001([^\002]*)\002/&HTMLpush($1)/ge ;

       	    $line =~ s/([<>])/&HTMLgtlt($1)/ge;
	    $line =~ s/(((http)|(ftp)|(gopher)):\/\/[^ \t\n\r\">]+)/<a href=\"$1\">$1<\/a>/gi;

	    foreach $key (keys(%html)) {
		$line =~ s/$key/<\/PRE>\n<HTML>$html{$key}<\/HTML>\n<PRE>/;
	    }
	    
	    if($subject eq "") {
		$subject = "<I>No subject</I>";
	    }

	    $page  = "Content-type: text/html\n\n";
	    $page .= "<HTML>\n<HEAD><TITLE> Message Page </TITLE></HEAD>\n";

	    local($icone) = &MakeIconLine($userid,$userkey,$msgnum,$msgid);
	    $page .= $icone;

	    $page .= "<P>\n";
	    $page .= "<HR>\n";
		    
	    $page .= "<H2>$subject</H2>\n";
	    $page .= "<I>\nFrom: $from<BR>\nTo: $to<BR>\nCc: $ccopy<BR>\n";
	    $page .= "Date: $date<BR>\nMsg-Id: $msgid<BR>\n";
	    $page .="Size: $size bytes<BR>\n</I>\n";
	    $page .="<HR>\n";	    
	    $page .="<PRE>$line</PRE>\n";
	    $page .="<HR>\n";	    
	    $page .= $icone;
              
	    $page .= &Copyright();
 	    $page .= "</BODY>\n</HTML>\n";
	} else {
	    &ELOG("can't access popserver");
	    $page= &AccessErrorPage("Sorry, POP Server error");
	}
    } else {
	&ELOG("wrong username or password");
	$page= &AccessErrorPage("Wrong username or password");
    }

    &popclose();

    return $page;
}

######## GetMessageInfo #########
# Get from (only the e-mail section) , subject and text field of a message

sub GetMessageInfo {
    local($userid,$userpasswd,$msgnum)=@_;
    local($s,$r);
    local($pop);
    local($from,$to,$ccopy,$subject,$date,$msgid,$size,$line);

    $pop=&socketinit($popserver,$popport);
    $pop=&popopen() if ($pop == 1);

    if($pop ne "+OK") {
	return ("-ERR", $from, $subject, $line);
    }

    ($s,$r)=&popaccess($userid,$userpasswd);

    if($s eq '+OK') {
	($s,$from,$to,$ccopy,$subject,$date,$msgid,$size,$line)=&popretr($msgnum,"allmsg");
	$from =~ tr/<>/  /;
    } 

    &popclose();

    return ($s, $from, $subject, $line);
}

######## DeleteMessage #########
# Send a delete request to POPserver

sub DeleteMessage {
    local($userid,$userpasswd,$msgnum)=@_;
    local($s,$r);
    local($pop);

    $pop=&socketinit($popserver,$popport);
    $pop=&popopen() if ($pop == 1);

    if($pop ne "+OK") {
	return ;
    }

    ($s,$r)=&popaccess($userid,$userpasswd);

    if($s eq '+OK') {
	($s,$r)=&popdele($msgnum);
    } 

    &popclose();

}

######## MessageFormPage #########
# return the HTML page listing the user's mail

sub MessageFormPage {
    local($userid,$userkey,$msgnum,$to,$subject,$text)=@_;

    local($page);

    $page  = "Content-type: text/html\n\n";    
    $page .= "<HTML>\n<HEAD><TITLE> Message Form Page </TITLE></HEAD>\n";
    $page .= "<BODY>\n<H1>WebMail message form</H1>\n";
    $page .= "Using this form you can send a message. Press the SEND button to send\n";
    $page .= "the message or follow the back link to abort the action\n";
    $page .= "<HR>\n";

    $page .= "<FORM METHOD=\"post\" ACTION=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/message+$msgnum/send\">\n";
    $page .="<B>From: ".&UserEMail($userid)."</B><P>\n";
    $page .= "<B>To:</B> <INPUT TYPE=\"text\" NAME=\"dest\" VALUE=\"$to\" SIZE=30><BR>\n";
    $page .= "<B>Cc:</B> <TEXTAREA name=\"carbon\" rows=2 cols=30></TEXTAREA><BR>\n";
    $page .= "<B>Subject:</B> <INPUT TYPE=\"text\" NAME=\"subject\" VALUE=\"$subject\" SIZE=50><P>\n";
    $page .= "<HR><P>\n";

    $page .= "<B>Text:</B> <TEXTAREA name=\"text\" rows=10 cols=80>$text</TEXTAREA><P>\n";
    $page .= "<PRE>                          <INPUT TYPE=\"submit\" VALUE=\"  Send  \">       <INPUT TYPE=\"reset\" VALUE=\"  Clear  \"> </PRE>\n";

    $page .= "</FORM>\n";
    $page .= "<HR>\n";
    

    $page .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/message+$msgnum/read\">Back</A> to message<P>\n";

    $page .= &Copyright();
    $page .= "</BODY>\n</HTML>\n";

    return $page;
    
}

######## SendErrorPage #########
# notify a send error

sub SendErrorPage {
    local($error,$userid,$userkey,$msgnum)=@_;
    local($page);

    $page  = "Content-type: text/html\n\n";    
    $page .= "<HTML>\n<HEAD><TITLE> Send Message Error Page </TITLE></HEAD>\n";
    $page .= "<BODY>\n<H1>WebMail send message result</H1>\n";
    $page .= "Your message has not been sent. WebMail has reported the error:<P>\n";
    $page .= "<BLINK><H2>$error</H2></BLINK>\n";
    $page .= "Follow this link to return to the ";
    if($msgnum != 0) {
	$page .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/message+$msgnum/read\">previous message</A>\n";
    } else {
	$page .= "<A HREF=\"$cgipath/webmail.cgi/$userid+$userkey/$popname+$popport/maillist/read\">mail list</A>\n";
    }
    $page .= &Copyright();

    return $page;
}



######## SaveMessage #########
# Save message to Local Disk

sub SaveMessage {
    local($userid,$userpasswd,$msgnum)=@_;
    local($s,$r);
    local($pop);
    local($page);

    $pop=&socketinit($popserver,$popport);
    $pop=&popopen() if ($pop == 1);

    if($pop ne "+OK") {
	&ELOG("can't open popserver socket");
	return &AccessErrorPage("POP Server is not responding");
    }

    ($s,$r)=&popaccess($userid,$userpasswd);

    if($s eq '+OK') {
	($s,$r)=&popquery("retr $msgnum",1);
	if($s eq '+OK') {
	    $page = "Content-type: application/binary\n\n";
	    $page .= $r;
   	} else {
	    $page = &AccessErrorPage("POP Server is not responding");
	}
    }


    &popclose();

    return $page;
}


###### Exit_Nicely #######

sub exit_nicely {
    &popclose();
    &UnlockDbmFile();
    exit;
}

###### Main ######

local(%dbf);
local(%CGI);
local($userid,$userkey,$userpasswd,$callIP);
local($popname);

# make the db lock file (if not exist)
if (!(-e $dblockfile)) {
    open (LOCKFILE,">$dblockfile");
    close LOCKFILE;
}

# this is for httpd's child processes termination
$SIG{"ALRM"} = 'exit_nicely';
alarm(200);

&ParseCGI(*CGI,*PATHINFO);

# get the caller's IP address
$callIP=$ENV{"REMOTE_ADDR"};

# handle an empty PATHINFO
if($PATHINFO[0] eq "") {
    @PATHINFO=split('/',"0+0/0+0/access");
}

# extract userid & USERKEY

if ($PATHINFO[0] =~ m/\+/) {    
    $userid = $`;		# left 
    $userkey = $';		# right
} else {
    print &AccessErrorPage("Wrong request format");
    exit ;
}

$popname="default";

if(($PATHINFO[1] ne "0+0") &&($popchangeON != 0)) {
    if ($PATHINFO[1] =~ m/\+/) {    
	$popname = $`;       	# left 
	$popport = $';		# right
    } else {
	print &AccessErrorPage("Wrong request format");
	exit ;
    }
}

$popserver = $popserverlist{$popname};

# extraction of state : access , maillist o message
local($state,$msgnum) = split('\+',$PATHINFO[2]);

# switch-case statement simulation

$_=$state;

SC1: {
    if (/^access$/) {		############  access matched
	# test for logon string
	if ($PATHINFO[3] eq "") {
	    print &AccessPage();
	} elsif ( $PATHINFO[3] eq "logon") {
	    # get form data: name e password
	    $userid = $CGI{"username"};
	    $userpasswd = $CGI{"userpasswd"};
	    
	    if($popchangeON == 1) {
		$popname=$CGI{"popserver"};
		$popserver = $popserverlist{$popname};
	    }

	    local($pop)=&socketinit($popserver,$popport);
	    $pop=&popopen() if ($pop == 1);

	    if($pop ne "+OK") {
		&ELOG("can't open popserver socket");
		&ALOG("user <$userid> access failed");
		print &AccessErrorPage("POP Server is not responding");
		exit;
	    }

	    local($s)=&popaccess($userid,$userpasswd);
	    &popclose();

	    if($s eq '-ERR') {
		&ELOG($s);
		&ALOG("user <$userid> access failed");
		print &AccessErrorPage("Unable to open your account");
		exit;
	    }

	    if(&LockDbmFile()) {
		if(!dbmopen(dbf,$dbname,0600))
		{
		    &UnlockDbmFile();
		    &ELOG("can't open dbm file");
		    &ALOG("user <$userid> access failed");
		    print &AccessErrorPage("Unable to open your account");
		    exit;
		}
		
		# now create the user record 
		$userkey = &createkey($userid,$userpasswd);
		($ckey,$ikey) = &splitkey($userkey);

		$thekey = $userid . $ikey;
		$timestamp = time;
		$dbf{$thekey} = &cryptstring($ckey,"$userid+$userpasswd+$callIP+$timestamp");
		dbmclose dbf;
		&UnlockDbmFile();

		&ALOG("user <$userid> access ok");
		# send the maillist page
		print &MailListPage($userid,$userkey,$userpasswd);
	    } else {
		&ELOG("can't lock dbm file");
		&ALOG("user <$userid> access failed");
		print &AccessErrorPage("Unable to open your account");
		exit;
	    }

	} else {
	    print &AccessErrorPage();
	}

 
	last SC1;
    }

    if (/^maillist$/) {		############ maillist matched
	# search userid e userpasswd

	# userid is already in $userid
	# userpasswd is into the database

	($userpasswd,$error)=&getuserrecord($userid,$userkey);
	if($userpasswd eq "") {
	    print &AccessErrorPage($error);
	    exit;
	}

	if($PATHINFO[3] eq "read") {
	    print &MailListPage($userid,$userkey,$userpasswd);
	} elsif ($PATHINFO[3] eq "delform") {
	    print &DeleteListPage($userid,$userkey,$userpasswd);
	} elsif ($PATHINFO[3] eq "delete") {
	    &ParseDeleteForm($userid,$userkey,$userpasswd);
	    print &DeleteListPage($userid,$userkey,$userpasswd);
	} 
	last SC1;
    }




    if (/^message$/) {		########### message matched
	# search userid e userpasswd

	($userpasswd,$error)=&getuserrecord($userid,$userkey);
	if($userpasswd eq "") {
	    print &AccessErrorPage($error);
	    exit;
	}
	
	# test for logon string
	if ($PATHINFO[3] eq "read") { #### read command
	    if($msgnum != 0) {
		print &ReadMessagePage($userid,$userkey,$userpasswd,$msgnum);
	    } else {
		print &MailListPage($userid,$userkey,$userpasswd);
	    }
	} elsif ( $PATHINFO[3] eq "delete") { # delete command
	    &DeleteMessage($userid,$userpasswd,$msgnum);
	    print &MailListPage($userid,$userkey,$userpasswd);

	} elsif ( $PATHINFO[3] eq "save") { # save command
	    print &SaveMessage($userid,$userpasswd,$msgnum);

	} elsif ( $PATHINFO[3] eq "compose") { # compose command
	    print &MessageFormPage($userid,$userkey,$msgnum,"","","");

	} elsif ( $PATHINFO[3] eq "reply") { # reply command
	    local($s,$from,$subject,$text)=&GetMessageInfo($userid,$userpasswd,$msgnum);

	    $from .= " ";
	    $from =~ m/\s*<*([^<\s]+\@[^\s>]+)>*/ ;
	    $from = $1;

	    if(!($subject =~ /^Re: /i)) {
		$subject = "Re: $subject";
	    }
	    print &MessageFormPage($userid,$userkey,$msgnum,$from,$subject,"");

	} elsif ( $PATHINFO[3] eq "replyinclude") { # include & reply command
	    local($s,$from,$subject,$text)=&GetMessageInfo($userid,$userpasswd,$msgnum);
	    if(!($subject =~ /^Re: /i)) {
		$subject = "Re: $subject";
	    }
	    

	    $from .= " ";
	    $from =~ m/\s*<*([^<\s]+\@[^\s>]+)>*/ ;
	    $from = $1;

	    local(@lines) = split("\n",$text);
	    local($i);
	    for ($i=0;$i<=$#lines;$i++) {
		$lines[$i] = "> $lines[$i]";
	    }
	    
	    $text = join("\n",@lines);

	    print &MessageFormPage($userid,$userkey,$msgnum,$from,$subject,$text);

	} elsif ( $PATHINFO[3] eq "forward") { # forward command
	    local($s,$from,$subject,$text)=&GetMessageInfo($userid,$userpasswd,$msgnum);

	    $text = "----------- start of forwarded message -----------\n" . $text;
	    $text .= "------------ end of forwarded message ------------\n";

	    print &MessageFormPage($userid,$userkey,$msgnum,"",$subject,$text);

	} elsif ( $PATHINFO[3] eq "send") { ###### send command: this is from the send form page 
	    local($dest,$ccopy,$subject,$text);
	    $dest = $CGI{"dest"};
	    $ccopy = $CGI{"carbon"};
	    $subject = $CGI{"subject"};
	    $text = $CGI{"text"};

	    $ccopy =~ s/\r//g;
	    $ccopy =~ s/\n/, /g;
	    $text =~ s/\r//g;


	    ($s,$error)=&SendUserMessage($userid,$dest,$ccopy,$subject,$text);

	    if($s eq "+OK") {
		# return to message page
		if($msgnum != 0) {
		    print &ReadMessagePage($userid,$userkey,$userpasswd,$msgnum);
		} else {
		    print &MailListPage($userid,$userkey,$userpasswd);
		}
	    } else {
		# print the send error page
		print &SendErrorPage($error,$userid,$userkey,$msgnum);
	    }
	} 

       

	last SC1;
    }

    ########### nothing matched: default action

    &ELOG("no action matched");
    print &AccessErrorPage("Wrong request format");
    exit;
}






