#!/usr/local/bin/perl
#############################
# WebMail install script    #
#############################

@distribution = (
		 ".workdir",
		 "cgi-bin",
		 "icons",
		 "cgi-bin/webmail.cgi",
		 "cgi-bin/popsocket.pl",
		 "cgi-bin/cgiparse.pl",
		 "icons/compose.gif",
		 "icons/delmulti.gif",
		 "icons/maillist.gif",
		 "icons/replyinc.gif",
		 "icons/delete.gif",
		 "icons/forward.gif",
		 "icons/reply.gif",
		 "icons/save.gif"
		 );


sub getstringsafe {
    local($req,$def)=@_;

    do {
	print "$req\n";
	print "[$def]" if ($def ne "");
	print "> ";
	$line=<>;
	chop $line;

	$line=$def if($line eq "");

	print "You have entered: [$line]\n";
	print "Are you sure? (y/n/q) ";
	$res=<>;
	print "\n";
	
	if($res =~ /q/i) {
	    print "Installation aborted.\n";
	    exit;
	}
	
    } while(!($res =~ /y/i));
	   
    $line;
}

sub finddistribution {
    local($cwd)=@_;
    foreach $file (@distribution) {
	local($ffn);
	$ffn = $cwd .'/'. $file;
	if(!(-e $ffn)) {
	    print "I've not found this file in your distibution:\n[$file]\n";
	    return 0;
	}
    }
    return 1;
}

##############################################
##############################################
local($cgipath);
local($htmlpath);
local($cgigid,$cgiuid);
local($popserver);
local($popport);
local($sendmail);
local($smailport);
local($timeout);
local($popchange);
local(%poplist);
##############################################
##############################################


print "\nWebMail 1.20 Installation Script\n";
print "Initializing...";

$hostname = `hostname`;
chop $hostname;

@localhost = gethostbyname($hostname);
$localhost = $localhost[0];

$hostdomain = $localhost;
$hostdomain =~ s/^$hostname\.//i;

$user=getpwuid($<);
print "you are $user\n";

$cwd = `pwd`;
chop($cwd);
$cwd .= '/'. $0;
$cwd =~ s/(.*)\/\/(.*)/\/$2/;
$cwd =~ s/\/install.pl//;

if($user ne "root") {
    print "You must be \"root\" to install WebMail!\n";
    exit;
}

while(! &finddistribution($cwd)) {
    local($path);
    print "I'm looking for distribution in [$cwd],\n";
    print "but I think I'm searching in a wrong place...\n";

    $path = &getstringsafe("What is the right path?");
    $cwd = `pwd`;
    chop($cwd);
    $cwd .= '/'. $path;
    $cwd =~ s/(.*)\/\/(.*)/\/$2/;
    $cwd =~ s/\/$//;
}

print "
I need some information about your HTTP system before 
beginning the installation of WebMail.
If you don't know the answer to a question, then 
abort the installation and check your HTTPD
configuration.
";

$perlpath=`which perl`;
chop $perlpath;

if(!((-e $perlpath) && (-x $perlpath))) {
    $perlpath="";
}

do {
    $cycle=0;
    $perlpath = &getstringsafe("What is the path for the PERL interpreter?",$perlpath);

    if(!(-e $perlpath)) {
	print "I can't find the [$perlpath] file\n";
	$cycle=1;
    }

    if(!(-x $perlpath)) {
	print "[$perlpath] is not an executable file\n";
	$cycle=1;
    }

} while($cycle);



do {
    $cycle=0;
    $cgipath = &getstringsafe("Where does your HTTP deamon look for CGI scripts?",
			      "/usr/local/etc/httpd/cgi-bin");
    if(!(-e $cgipath)) {
	print "I can't find the [$cgipath] directory\n";
	$cycle=1;
    }
} while($cycle);

do {
    local($uid);
    $cycle=0;
    $cgiuid  = &getstringsafe("Under which USER name will your
HTTPD run CGI scripts?","nobody");

    if(!getpwnam($cgiuid)) {
	print "User $cgiuid does not exist!\n";
	$cycle=1;
    }

} while($cycle);

do {
    $cycle=0;
    $cgigid  = &getstringsafe("Under which GROUP name will your
HTTPD run CGI scripts?","nogroup");

    if(!getgrnam($cgigid)) {
	print "Group $cgigid does not exist!\n";
	$cycle=1;
    }
} while($cycle);


do {
    $cycle=0;
    $htmlpath = &getstringsafe("What is the default place where
your HTTP deamon looks for HTML\ndocuments?","/usr/local/etc/httpd/htdocs");

    if(!(-e $htmlpath)) {
	print "I can't find the [$htmlpath] directory\n";
	$cycle=1;
    }
} while($cycle);

print "I won't test your next answers...
Please, respond correctly.
";

$popserver = &getstringsafe("What is the network address of\nyour default POP3 server?",$localhost);
$popport = &getstringsafe("What is the POP3 server socket port number?","110");
$poplist{"default"}=$popserver;

$sendmail = &getstringsafe("What is the network address of\nyour default sendmail server?",$popserver);
$smailport = &getstringsafe("What is the sendmail socket port number?","25");

$timeout=600;

print '
Do you have a network architecture that masks the
true address of users (eg. "joe" is "joe@domain.it"
and not "joe@computer.domain.it")? (y/n)';

if(<> =~ /^y$/i) {
    $udomain = &getstringsafe("What is your external domain?",$hostdomain);
} else {
    $udomain="";
    print "Ok! Let's go on...\n";
}


$popchange = &getstringsafe("Do you wish to use the MULTIPLE POP3 SERVER feature? (yes/no)","no");
if($popchange =~ /^yes$/i) {
    $popchange=1;

    print "Now you must enter the list of
POP3 servers you want to enable,
as ALIAS/ADDRESS pairs.
Example: $hostname/$localhost
The pair default/$popserver has
already been entered for you.
Just enter \"quit\" to end the list.
";

    do {
	$cycle=1;

	$poppair=&getstringsafe("Enter an Alias/address pair:","");
	if($poppair =~ /^quit/i) {
	    $cycle=0;
	} else {
	    ($alias,$address)=split('/',$poppair);
	    $poplist{$alias}=$address;
	}

    } while ($cycle);

    print "This is the list you have entered:\n";
    foreach (keys(%poplist)) {
	print "   ".$_ ." / ".$poplist{$_}."\n";
    }

    print "
You should edit the webmail.conf file in 
the webmail/cgi-bin directory if you want
to modify this list.
";

} else {
    $popchange=0;
}

print "
Now I'll create the webmail.conf file
in the webmail/cgi-bin directory.
";

if(open (CFGFILE,">$cwd/cgi-bin/webmail.conf")){
    select(CFGFILE);

    print '
##############################################
## WebMail 1.20 Configuration File          ##
##############################################

$cgipath = "/cgi-bin"; # default cgi-bin directory

$webmaildir = "' . $cwd .'"; # where you have expanded the webmail distribution

$dbname = "$webmaildir/.workdir/.webmaildb"; # dbm-file (without .pag/.dir extension) for users

$dblockfile = "$webmaildir/.workdir/.webmaillock"; # file used as alias of the dbm-file 
                                           # for lock/unlock operations

$popserver = "'.$popserver.'"; # default popserver

$popport = '.$popport.';			# standard popserver port number

$sendmailserver = "'.$sendmail.'";	# default sendmail server

$sendmailport = '.$smailport.';		# standard sendmail port number

$elog = "$webmaildir/.workdir/webmail_error.log"; # error-log file name

$alog = "$webmaildir/.workdir/webmail_access.log"; # access-log file name

$icondir = "/webmail/icons"; # path for icons

$timeout = 600;			# user password expiration time in seconds

$linesinlist = 0;		# how many lines of msg text must appear in Mail List Page
				# 0 means that only Sender and Subject fields will appear

$userdomain = "'.$udomain.'";		# the default user domain:
				# if you have a network architecture that masks the
				# true address of users (eg. "bilbo" is "bilbo@crs4.it"),
				# then put the domain into this variable ("crs4.it");
				# if you do not, the user "bilbo" will be "bilbo@$popserver".

$popchangeON = '.$popchange.';		# change this to disable the popserver change feature

';

    foreach (keys(%poplist)) {
	print '$popserverlist{"' . $_ . '"}="' .$poplist{$_}. '";';
	print "\n";
    }


    print "1;\n";

    close(CFGFILE);
    select(STDOUT);

#change the perl path in webmail.cgi

    if(open(WMFILE,"<$cwd/cgi-bin/webmail.cgi")) {
	local(@webmailfile)=<WMFILE>;
	$webmailfile[0]="#!$perlpath\n";
	close(WMFILE);

	if(open(WMFILE,">$cwd/cgi-bin/webmail.cgi")) {
	    foreach (@webmailfile) {
		print WMFILE $_;
	    }
	    close(WMFILE);
	} else {
	    print "Warning: I can't modify the perl path\n in webmail.cgi\n";
	    print "You will have to modify them manually...\n";
	}
    } else {
	print "Warning: I can't read webmail.cgi\n";
	print "You will have to modify the perl path manually...\n";
    }

} else {
    print "I can't create the [$cwd/cgi-bin/webmail.conf] file.\n";
    print "Installation aborted.\n";
    exit;
}


print '
Now I want to create all links needed by WebMail
and change file ownership and permissions.
Do you want to continue? (write "yes" or "no") ';

if(<> !~ /^yes$/i) {
    print "I have done all this boring work... And you say NO?\n";
    print "Ok, Ok. NO means NO...Installation aborted.\n";
    exit;
}

# create the links ...

$links{"$cwd/cgi-bin/webmail.cgi"}="$cgipath/webmail.cgi";
$links{"$cwd/cgi-bin/webmail.conf"}="$cgipath/webmail.conf";
$links{"$cwd"}="$htmlpath/webmail";

foreach (keys(%links)) {

    if(-e $links{$_}) {
	unlink $links{$_};
    }

    if(!symlink($_,$links{$_})) {
	print "Sorry, I'm not able to link\n    [$_]\nto\n    [$links{$_}]\n";
	print "Installation aborted.\n";
	exit;
    }

    print "$links{$_} ==> [$_]\n";
}

# change owner and permissions

print "I'm changing the owner/group for 
all webmail files to [$cgiuid:$cgigid]
";
system("chown -R $cgiuid:$cgigid $cwd");





