#!/usr/crs4/bin/perl
####################################
#  Webmail is a cgi script that
#  let you read your mail from
#  Mosaic or Netscape
####################################



require 'popsocket.pl';
require 'cgi_lib.pl';





# Pathinfos from Mosaic

# 0+0/0+0/access
# 0+0/0+0/access/logon
# userid+USERKEY/POPSERVER+POPPORT/maillist
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/read
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/delete
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/reply
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/replyinclude
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/compose
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/forward
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/send
# userid+USERKEY/POPSERVER+POPPORT/message+MESSNUM/save/MESSID

# database record template  

# USERID+PASSWORD+TIMESTAMP    <--- secs from 01/01/1970


######## config variables #############
$webmaildir = '/~bilbo/cgi-bin'; # path for webmail.cgi
$dbname = '/u/cgdata/bilbo/.webmail/.webmaildb';
$popserver = 'bruckner.crs4.it';
$popport = 110;
$sendmailport = 25;
$elog = '/u/cgdata/bilbo/.webmail/webmail_error.log';
$alog = '/u/cgdata/bilbo/.webmail/webmail_access.log';
$icondir = '/~bilbo/icone';	# path for icons
$timeout = 600;			# user password expiration time
$linesinlist = 0;		# how many lines of msg text must appear in Mail List Page 
$userdomain = "crs4.it";		# user "bilbo" is "bilbo@crs4.it"

$popchangeON = 1;		# change this to disable the popserver change feature


######## utility function ########
$html_region = 0 ;

sub HTMLgtlt {
    local($ch)=@_;
    return '&gt;' if ($ch eq ">");
    return '&lt;' if ($ch eq "<");
}

sub HTMLpush {
    local ($entry) = @_ ;
    local ($key) = " \003HTML-$html_region ";
    $html{$key} = $entry ;
    $html_region++ ;
    return ($key) ;
}

######## log functions ###########
sub ALOG {

    local($r)=open(LOGFILE,">>$alog");

    local($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
    local($pre)=sprintf("[%02d/%02d/%02d %02d:%02d:%02d]",$mday,$mon+1,$year,$hour,$min,$sec);

    if($r) {
	foreach $str (@_) {
	    print LOGFILE "$pre $str\n";
	}
	close LOGFILE;
    } 
}


sub ELOG {

    local($r)=open(LOGFILE,">>$elog");

    if($r) {
	foreach $str (@_) {
	    print LOGFILE "$str\n";
	}
	close LOGFILE;
    } 
}


####### createkey function ########
# make a unique key for USER + PASSWD

sub createkey {
    local($u,$p) = @_;

    return "$u"."KEY";		# too trivial? but... it's only the first version!
}

####### getuserrecord ########
# get a user record from dbm file

sub getuserrecord {
    local($uid,$ukey) = @_;
    local(%dbf);
    local($error,$record,$userpasswd,$timestamp);

    if(!dbmopen(dbf,$dbname,0600))
    {
	&ELOG("can't open dbm file");
	$error="Unable to open your account";
    } else {
	
	$record = $dbf{$ukey};  
			       
	if( $record =~ m/^$uid\+/ ) {
	    ($uid,$userpasswd,$timestamp) = split('\+',$record);
	    if ((time - $timestamp) > $timeout) {
		&ELOG("user inactivity timeout expired");
		$userpasswd="";
		$error="Inactivity timeout expired.<P>Your password is no longer valid";

	    } else {	    
		$timestamp = time;
		$dbf{$ukey} = "$uid+$userpasswd+$timestamp";
	    }
	} else {
	    &ELOG("user key not matches the userid");
	    $error="Unable to open your account";
	}
	
	dbmclose dbf;
    }

    return ($userpasswd,$error);
}



######## AskTruName ############
## this function is not directly related to POP server
## but uses the same protocol for open, query and close

sub AskTrueName {
    local ($userid)=@_;
    local($s,$r);
    local($truename);
    local($sendmail);

    
    $sendmail=&popinit($popserver,$sendmailport);
    $sendmail=&popopen() if ($sendmail == 1);

    if($sendmail ne "+OK") {
	&ELOG("can't open sendmail socket");
	$s = '-ERR';
	$truename = "Unknown";
    } else {
	($s,$r)=&sendmailquery("vrfy $userid",0);
	if($s eq '+OK') {
	    $r =~ m/^(.*) <(.*)>/i;
	    $truename = $1;
	} else {
	    &ELOG("sendmail verify userid failed","$r");
	    $truename = "Unknown";
	}
    }

    &popclose();
    return ($s,$truename);
}

######## Copyright ########
# return the HTML string with the copyright notice

sub Copyright {
    local ($notice);
    $notice =  "<HR><H5>WebMail - Copyright \&copy; 1995 CRS4 Cagliari - Luca Manunza<BR>\n";
    $notice .= "<I>For more information please e-mail to <A HREF=\"mailto:bilbo\@crs4.it\">bilbo\@crs4.it</A>.</I></H5>\n";

    $notice;
}

######## AccessErrorPage #########
# return the HTML page with Error string and a link to the access page

sub AccessErrorPage {
    local($msg)=@_;
    local($page);

    $page  = "Content-type: text/html\n\n";
    $page .= "<HTML>\n<HEAD><TITLE> Access Error Page </TITLE></HEAD>\n";
    $page .= "<BODY>\n<H1>WebMail access error</H1>\n";
    $page .= "The server has reported:\n";
    $page .= "<H2>$msg</H2>\n";
    $page .= "Please follow this link to the correct ";
    $page .= "<A HREF=\"$webmaildir/webmail.cgi/0+0/$popserver+$popport/access\">WebMail Access Page</A>\n";
    $page .= &Copyright();
    $page .= "</BODY>\n</HTML>\n";

    return $page;
}

######## AccessPage #########
# return the HTML page with the form for USERNAME and PASSWORD

sub AccessPage {

    local($page);
    $page  = "Content-type: text/html\n\n";    
    $page .= "<HTML>\n<HEAD><TITLE> Access Page </TITLE></HEAD>\n";
    $page .= "<BODY>\n<H1>WebMail Access Page</H1>\n";
    $page .= "To access your mail you have to fill this form with your name and password.\n";
    $page .= "<HR>\n";

    $page .= "<FORM METHOD=\"POST\" ACTION=\"$webmaildir/webmail.cgi/0+0/$popserver+$popport/access/logon\">\n";
    $page .= "USER NAME:<INPUT TYPE=\"TEXT\" NAME=\"username\" SIZE=30><P>\n";
    $page .= "PASSWORD: <INPUT TYPE=\"PASSWORD\" NAME=\"userpasswd\" SIZE=30><P>\n";

    if($popchangeON != 0) {
	$page .= "<HR>\n";
	$page .= "If you needs it, you can specify here your POP server:<P>\n";
	$page .= "POP Server: <SELECT  NAME=\"popserver\" >\n";
	$page .= "<OPTION> buckaroo.crs4.it\n";
	$page .= "<OPTION> popserver.crs4.it\n";
	$page .= "<OPTION> bruckner.crs4.it\n";
	$page .= "<OPTION> sardinia.portoconte.crs4.it\n";
	$page .= "</SELECT>\n";	
    }
    
    $page .= "<PRE>           <INPUT TYPE=\"SUBMIT\" VALUE=\"  Go to maillist  \">         <INPUT TYPE=\"RESET\" VALUE=\"  Clear  \"> </PRE>\n";
    $page .= "</FORM>\n";
    $page .= &Copyright();
    $page .= "</BODY>\n</HTML>\n";

    return $page;
}


######## MailListPage #########
# return the HTML page listing the user's mail

sub MailListPage {
    local($userid,$userkey,$userpasswd)=@_;
    local($page);
    local($s,$r);
    local(@lista);
    local($pop);
    

    $page  = "Content-type: text/html\n\n";

    $page .= "<HTML>\n<HEAD><TITLE> MailList Page </TITLE></HEAD>\n";
    $page .= "<BODY>\n<H1>WebMail Mail List Page</H1>\n";
    $page .= "<H2>" . $userid . "\'s mail</H2>\n";
    $page .= "This is your actual mail. You can click on a subject to read the corresponding message.\n";
    $page .= "Please note that if your mail exceeds 100 Kbytes, you should consider removing the oldest messages,\n";
    $page .= "otherwise we will do it for you...<P>\n";

    # iconline
    $page .= "<HR>\n";
    $page .= "<A HREF=\"$webmaildir/webmail.cgi/$userid+$userkey/$popserver+$popport/maillist\">";
    $page .= "<IMG ALT=\"Mail List\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/maillist.gif\">";
    $page .= "</A>\n";
    $page .= "<A HREF=\"$webmaildir/webmail.cgi/$userid+$userkey/$popserver+$popport/message+0/compose\">";
    $page .= "<IMG ALT=\"Compose\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/compose.gif\">";
    $page .= "</A>\n";
    $page .= "<HR>\n";

# now create the mail list querying the server

    $pop=&popinit($popserver,$popport);
    $pop=&popopen() if ($pop == 1);

    if($pop ne "+OK") {
	&ELOG("can't open popserver socket");
	$page= &AccessErrorPage("POP Server is not responding");
	return $page;
    }

    ($s,$r)=&popaccess($userid,$userpasswd);

    if($s eq '+OK') {
	
	($s,@lista) = &poplist();

	if(($s eq '+OK') && ($#lista > 1)) {

	    $lista[0] =~ s/octets/bytes/i;
	    $page .= "We've $lista[0] for you.<P>\n<UL>\n";

	    local($from,$to,$subject,$date,$msgid,$size,$line);
	    local($i);
	    for($i=1; $i<($#lista); $i++) {
		($s,$from,$to,$subject,$date,$msgid,$size,$line)=&popretr($lista[$i],$linesinlist);

		if($s eq '+OK') {
		    $from =~ s/([<>])/&HTMLgtlt($1)/ge;
		    $msgid =~ s/([<>])//g;
		    $line =~ s/([<>])/&HTMLgtlt($1)/ge;
		    $to =~ s/([<>])/HTMLgtlt($1)/ge;
		    $subject =~ s/([<>])/HTMLgtlt($1)/ge;

		    $subject = "No subject" if ($subject =~ /^\s*$/);

		    $page .= "<LI><B>$from</B> - ";
		    
		    $page .="<A NAME=\"" . $msgid ."\" HREF=\"$webmaildir/webmail.cgi/$userid+$userkey/$popserver+$popport/message+$lista[$i]/read\" ><I>$subject</I></A>\n";

		    if(($line ne "\n") && ($line ne "")) {
			$page .= "<UL><LI>\"$line\"</UL>\n";
		    }
		    
		} else {
		    $page .= "<LI>THIS MESSAGE IS MISSED\n";
		}
	    }

	    $page .="</UL>\n";

	} else {
	    $page .= "<B><I>Sorry, no messages for you.</I></B><P>\n";
	}

	# iconline
	$page .= "<HR>\n";
	$page .= "<A HREF=\"$webmaildir/webmail.cgi/$userid+$userkey/$popserver+$popport/maillist\">";
	$page .= "<IMG ALT=\"Mail List\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/maillist.gif\">";
	$page .= "</A>\n";
	$page .= "<A HREF=\"$webmaildir/webmail.cgi/$userid+$userkey/$popserver+$popport/message+0/compose\">";
	$page .= "<IMG ALT=\"Compose\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/compose.gif\">";
	$page .= "</A>\n";
	
	$page .= &Copyright();
	$page .= "</BODY>\n</HTML>\n";
	
    } else {
	&ELOG("wrong username or password");
	$page= &AccessErrorPage("Wrong username or password");
    }

    &popclose();
    return $page;
}


######## MakeIconLine ############
# build the HTML section of icon's line

sub MakeIconLine {
    local($userid,$userkey,$msgnum,$msgid)=@_;

    local ($line);
    
    $line .= "<A HREF=\"$webmaildir/webmail.cgi/$userid+$userkey/$popserver+$popport/maillist\#$msgid\">";
    $line .= "<IMG ALT=\"Mail List\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/maillist.gif\">";
    $line .= "</A>\n";
    $line .= "<A HREF=\"$webmaildir/webmail.cgi/$userid+$userkey/$popserver+$popport/message+$msgnum/delete\">";
    $line .= "<IMG ALT=\"Delete\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/delete.gif\">";
    $line .= "</A>\n";
    $line .= "<A HREF=\"$webmaildir/webmail.cgi/$userid+$userkey/$popserver+$popport/message+$msgnum/reply\">";
    $line .= "<IMG ALT=\"Reply\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/reply.gif\">";
    $line .= "</A>\n";
    $line .= "<A HREF=\"$webmaildir/webmail.cgi/$userid+$userkey/$popserver+$popport/message+$msgnum/replyinclude\">";
    $line .= "<IMG ALT=\"Reply-Include\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/replyinc.gif\">";
    $line .= "</A>\n";
    $line .= "<A HREF=\"$webmaildir/webmail.cgi/$userid+$userkey/$popserver+$popport/message+$msgnum/forward\">";
    $line .= "<IMG ALT=\"Forward\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/forward.gif\">";
    $line .= "</A>\n";
    $line .= "<A HREF=\"$webmaildir/webmail.cgi/$userid+$userkey/$popserver+$popport/message+$msgnum/compose\">";
    $line .= "<IMG ALT=\"Compose\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/compose.gif\">";
    $line .= "</A>\n";
    $line .= "<A HREF=\"$webmaildir/webmail.cgi/$userid+$userkey/$popserver+$popport/message+$msgnum/save/MAIL$msgnum\">";
    $line .= "<IMG ALT=\"Save\" WIDTH=89 HEIGHT=36 HSPACE=0 BORDER=1 SRC=\"$icondir/save.gif\">";
    $line .= "</A>\n";
    
    return $line;
}

######## ReadMessagePage #########
# return the HTML page listing the user's mail

sub ReadMessagePage {
    local($userid,$userkey,$userpasswd,$msgnum)=@_;
    local($page);
    local($s,$r);
    local(@lista);
    local($pop);

    $pop=&popinit($popserver,$popport);
    $pop=&popopen() if ($pop == 1);

    if($pop ne "+OK") {
	&ELOG("can't open popserver socket");
	$page= &AccessErrorPage("POP Server is not responding");
	return $page;
    }

    ($s,$r)=&popaccess($userid,$userpasswd);

    if($s eq '+OK') {
	
	local($from,$to,$subject,$date,$msgid,$size,$line);
	($s,$from,$to,$subject,$date,$msgid,$size,$line)=&popretr($msgnum,"allmsg");
	if($s eq '+OK') {
       	    $from =~ s/([<>])/&HTMLgtlt($1)/ge;
       	    $msgid =~ s/([<>])//g;
	    $subject =~ s/([<>])/HTMLgtlt($1)/ge;

	    $line =~ s/<HTML>/\001/gi ;
	    $line =~ s/<\/HTML>/\002/gi ;
	    $line =~ s/\001([^\002]*)\002/&HTMLpush($1)/ge ;

       	    $line =~ s/([<>])/&HTMLgtlt($1)/ge;
	    $line =~ s/(((http)|(ftp)|(gopher)):\/\/[^ \t\n\r\">]+)/<a href=\"$1\">$1<\/a>/gi;

	    foreach $key (keys(%html)) {
		$line =~ s/$key/<\/PRE>\n<HTML>$html{$key}<\/HTML>\n<PRE>/;
	    }
	    
	    if($subject eq "") {
		$subject = "<I>No subject</I>";
	    }

	    $page  = "Content-type: text/html\n\n";
	    $page .= "<HTML>\n<HEAD><TITLE> Message Page </TITLE></HEAD>\n";

	    local($icone) = &MakeIconLine($userid,$userkey,$msgnum,$msgid);
	    $page .= $icone;

	    $page .= "<P>\n";
	    $page .= "<HR>\n";
		    
	    $page .= "<H2>$subject</H2>\n";
	    $page .= "<I>\nFrom: $from<BR>\nDate: $date<BR>\nMsg-Id: $msgid<BR>\nSize: $size bytes<BR>\n</I>\n";
	    $page .="<HR>\n";	    
	    $page .="<PRE>$line</PRE>\n";
	    $page .="<HR>\n";	    
	    $page .= $icone;
              
	    $page .= &Copyright();
 	    $page .= "</BODY>\n</HTML>\n";
	} else {
	    &ELOG("can't access popserver");
	    $page= &AccessErrorPage("Sorry, POP Server error");
	}
    } else {
	&ELOG("wrong username or password");
	$page= &AccessErrorPage("Wrong username or password");
    }

    &popclose();

    return $page;
}

######## GetMessageInfo #########
# Get from (only the e-mail section) , subject and text field of a message

sub GetMessageInfo {
    local($userid,$userpasswd,$msgnum)=@_;
    local($s,$r);
    local($pop);
    local($from,$to,$subject,$date,$msgid,$size,$line);

    $pop=&popinit($popserver,$popport);
    $pop=&popopen() if ($pop == 1);

    if($pop ne "+OK") {
	return ("-ERR", $from, $subject, $line);
    }

    ($s,$r)=&popaccess($userid,$userpasswd);

    if($s eq '+OK') {
	($s,$from,$to,$subject,$date,$msgid,$size,$line)=&popretr($msgnum,"allmsg");
	$from =~ tr/<>/  /;
    } 

    &popclose();

    return ($s, $from, $subject, $line);
}

######## DeleteMessage #########
# Send a delete request to POPserver

sub DeleteMessage {
    local($userid,$userpasswd,$msgnum)=@_;
    local($s,$r);
    local($pop);

    $pop=&popinit($popserver,$popport);
    $pop=&popopen() if ($pop == 1);

    if($pop ne "+OK") {
	return ;
    }

    ($s,$r)=&popaccess($userid,$userpasswd);

    if($s eq '+OK') {
	($s,$r)=&popdele($msgnum);
    } 

    &popclose();

}

######## MessageFormPage #########
# return the HTML page listing the user's mail

sub MessageFormPage {
    local($userid,$userkey,$msgnum,$to,$subject,$text)=@_;

    local($page);

    $page  = "Content-type: text/html\n\n";    
    $page .= "<HTML>\n<HEAD><TITLE> Message Form Page </TITLE></HEAD>\n";
    $page .= "<BODY>\n<H1>WebMail message form</H1>\n";
    $page .= "Using this form you can send a message. Press the SEND button to send\n";
    $page .= "the message or follow the back link to abort the action\n";
    $page .= "<HR>\n";

    $page .= "<FORM METHOD=\"POST\" ACTION=\"$webmaildir/webmail.cgi/$userid+$userkey/$popserver+$popport/message+$msgnum/send\">\n";
    $page .="<B>From: $userid\@$userdomain</B><P>\n";
    $page .= "<B>To:</B> <INPUT TYPE=\"TEXT\" NAME=\"dest\" VALUE=\"$to\" SIZE=30><BR>\n";
    $page .= "<B>Cc:</B> <TEXTAREA name=\"carbon\" rows=2 cols=30></TEXTAREA><BR>\n";
    $page .= "<B>Subject:</B> <INPUT TYPE=\"TEXT\" NAME=\"subject\" VALUE=\"$subject\" SIZE=50><P>\n";
    $page .= "<HR><P>\n";

    $page .= "<B>Text:</B> <TEXTAREA name=\"text\" rows=10 cols=80>$text</TEXTAREA><P>\n";
    $page .= "<PRE>                          <INPUT TYPE=\"SUBMIT\" VALUE=\"  Send  \">       <INPUT TYPE=\"RESET\" VALUE=\"  Clear  \"> </PRE>\n";

    $page .= "</FORM>\n";
    $page .= "<HR>\n";
    

    $page .= "<A HREF=\"$webmaildir/webmail.cgi/$userid+$userkey/$popserver+$popport/message+$msgnum/read\">Back</A> to message<P>\n";

    $page .= &Copyright();
    $page .= "</BODY>\n</HTML>\n";

    return $page;
    
}

######## SaveMessage #########
# Save message to Local Disk

sub SaveMessage {
    local($userid,$userpasswd,$msgnum)=@_;
    local($s,$r);
    local($pop);
    local($page);

    $pop=&popinit($popserver,$popport);
    $pop=&popopen() if ($pop == 1);

    if($pop ne "+OK") {
	&ELOG("can't open popserver socket");
	return &AccessErrorPage("POP Server is not responding");
    }

    ($s,$r)=&popaccess($userid,$userpasswd);

    if($s eq '+OK') {
	($s,$r)=&popquery("retr $msgnum",1);
	if($s eq '+OK') {
	    $page = "Content-type: application/binary\n\n";
	    $page .= $r;
   	} else {
	    $page = &AccessErrorPage("POP Server is not responding");
	}
    }


    &popclose();

    return $page;
}


###### Exit_Nicely #######

sub exit_nicely {
    &popclose();
    exit;
}

###### Main ######

local(%dbf);
local(%incgi);
local($userid,$userkey,$userpasswd);

# this is for httpd's child processes termination
$SIG{"ALRM"} = 'exit_nicely';
alarm(200);

@pathinfo = split("\/",$ENV{"PATH_INFO"});
&ReadParse(*incgi);

# estrae userid & USERKEY

if ($pathinfo[1] =~ m/\+/) {    
    $userid = $`;		# left 
    $userkey = $';		# right
} else {
    print &AccessErrorPage("Wrong request format");
    exit ;
}


if(($pathinfo[2] ne "0+0") &&($popchangeON != 0)) {
    if ($pathinfo[2] =~ m/\+/) {    
	$popserver = $`;       	# left 
	$popport = $';		# right
    } else {
	print &AccessErrorPage("Wrong request format");
	exit ;
    }
}

# extraction of state : access , maillist o message
local($state,$msgnum) = split('\+',$pathinfo[3]);

# switch-case statement simulation

$_=$state;

SC1: {
    if (/^access$/) {		############  access matched
	# test for logon string
	if ($pathinfo[4] eq "") {
	    print &AccessPage();
	} elsif ( $pathinfo[4] eq "logon") {
	    # get form data: name e password
	    $userid = $incgi{"username"};
	    $userpasswd = $incgi{"userpasswd"};
	    
	    if($popchangeON == 1) {
		$popserver=$incgi{"popserver"};
	    }

	    local($pop)=&popinit($popserver,$popport);
	    $pop=&popopen() if ($pop == 1);

	    if($pop ne "+OK") {
		&ELOG("can't open popserver socket");
		&ALOG("user <$userid> access failed");
		print &AccessErrorPage("POP Server is not responding");
		exit;
	    }

	    local($s)=&popaccess($userid,$userpasswd);
	    &popclose();

	    if($s eq '-ERR') {
		&ELOG($s);
		&ALOG("user <$userid> access failed");
		print &AccessErrorPage("Unable to open your account");
		exit;
	    }

	    if(!dbmopen(dbf,$dbname,0600))
	    {
		&ELOG("can't open dbm file");
		&ALOG("user <$userid> access failed");
		print &AccessErrorPage("Unable to open your account");
		exit;
	    }
	    
	    # now create the user record 
	    $userkey = &createkey($userid,$userpasswd);
	    $timestamp = time;
	    $dbf{$userkey} = "$userid+$userpasswd+$timestamp";
	    dbmclose dbf;

	    &ALOG("user <$userid> access ok");
	    # send the maillist page
	    print &MailListPage($userid,$userkey,$userpasswd);

	} else {
	    print &AccessErrorPage();
	}

 
	last SC1;
    }

    if (/^maillist$/) {		############ maillist matched
	# search userid e userpasswd

	# userid is already in $userid
	# userpasswd is into the database

	($userpasswd,$error)=&getuserrecord($userid,$userkey);
	if($userpasswd eq "") {
	    print &AccessErrorPage($error);
	    exit;
	}

	print &MailListPage($userid,$userkey,$userpasswd);
	last SC1;
    }




    if (/^message$/) {		########### message matched
	# search userid e userpasswd

	($userpasswd,$error)=&getuserrecord($userid,$userkey);
	if($userpasswd eq "") {
	    print &AccessErrorPage($error);
	    exit;
	}
	
	# test for logon string
	if ($pathinfo[4] eq "read") { #### read command
	    if($msgnum != 0) {
		print &ReadMessagePage($userid,$userkey,$userpasswd,$msgnum);
	    } else {
		print &MailListPage($userid,$userkey,$userpasswd);
	    }
	} elsif ( $pathinfo[4] eq "delete") { # delete command
	    &DeleteMessage($userid,$userpasswd,$msgnum);
	    print &MailListPage($userid,$userkey,$userpasswd);

	} elsif ( $pathinfo[4] eq "save") { # save command
	    print &SaveMessage($userid,$userpasswd,$msgnum);

	} elsif ( $pathinfo[4] eq "compose") { # compose command
	    print &MessageFormPage($userid,$userkey,$msgnum,"","","");

	} elsif ( $pathinfo[4] eq "reply") { # reply command
	    local($s,$from,$subject,$text)=&GetMessageInfo($userid,$userpasswd,$msgnum);
	    if(!($subject =~ /^Re: /i)) {
		$subject = "Re: $subject";
	    }
	    print &MessageFormPage($userid,$userkey,$msgnum,$from,$subject,"");

	} elsif ( $pathinfo[4] eq "replyinclude") { # include & reply command
	    local($s,$from,$subject,$text)=&GetMessageInfo($userid,$userpasswd,$msgnum);
	    if(!($subject =~ /^Re: /i)) {
		$subject = "Re: $subject";
	    }
	    
	    local(@lines) = split("\n",$text);
	    local($i);
	    for ($i=0;$i<=$#lines;$i++) {
		$lines[$i] = "> $lines[$i]";
	    }
	    
	    $text = join("\n",@lines);

	    print &MessageFormPage($userid,$userkey,$msgnum,$from,$subject,$text);

	} elsif ( $pathinfo[4] eq "forward") { # forward command
	    local($s,$from,$subject,$text)=&GetMessageInfo($userid,$userpasswd,$msgnum);

	    $text = "----------- start of forwarded message -----------\n" . $text;
	    $text .= "------------ end of forwarded message ------------\n";

	    print &MessageFormPage($userid,$userkey,$msgnum,"",$subject,$text);

	} elsif ( $pathinfo[4] eq "send") { ###### send command: this is from the send form page 
	    local($dest,$ccopy,$subject,$text);
	    $dest = $incgi{"dest"};
	    $ccopy = $incgi{"carbon"};
	    $subject = $incgi{"subject"};
	    $text = $incgi{"text"};

	    $ccopy =~ s/\r//g;
	    $ccopy =~ s/\n/, /g;
	    $text =~ s/\r//g;

	    # ask truename to popserver's sendmail
	    ($s,$usertruename) = &AskTrueName($userid);

	    # send the message via sendmail
	    if($dest ne "") {
		open(MAIL, "| /usr/sbin/sendmail $dest");
		print MAIL "Cc: $ccopy\n";
		print MAIL "From: $usertruename <$userid\@$userdomain>\n";
		print MAIL "Subject: $subject \n\n";
		print MAIL "$text\n";
		close MAIL;
	    }
	    
	    # return to message page
	    if($msgnum != 0) {
		print &ReadMessagePage($userid,$userkey,$userpasswd,$msgnum);
	    } else {
		print &MailListPage($userid,$userkey,$userpasswd);
	    }
	} 

       

	last SC1;
    }

    ########### nothing matched: default action

    &ELOG("no action matched");
    print &AccessErrorPage("Wrong request format");
    exit;
}






